/*
 * Copyright (c) 2012-2017 Andes Technology Corporation
 * All rights reserved.
 *
 */

#include "config.h"
#include "platform.h"

extern void reset_vector(void);

/* This must be a leaf function, no child function */
void __platform_init (void) __attribute__((naked));
void __platform_init(void)
{
	/* Do your platform low-level initial */

	__asm("ret");
}


void c_startup(void)
{
#define MEMCPY(des, src, n)     __builtin_memcpy ((des), (src), (n))
#define MEMSET(s, c, n)         __builtin_memset ((s), (c), (n))
	/* Data section initialization */
	extern char  _edata, _end;
	unsigned int size;
//#ifndef CFG_BURN
//	/* We don't need to do it in BURN mode because it has been done by loader. */
	extern char __data_lmastart, __data_start;
//
//	/* Copy data section from LMA to VMA */
	size = &_edata - &__data_start;
	MEMCPY(&__data_start, &__data_lmastart, size);

//#endif

	/* Clear bss section */
	size = &_end - &_edata;
	MEMSET(&_edata, 0, size);
}

void system_init(void)
{
	/*
	 * Do your system reset handling here
	 */
	/* Reset the CPU reset vector for this program. */

	//AE250_SMU->RESET_VECTOR = (unsigned int)(long)reset_vector;

	/* Enable PLIC features */
//	if (read_csr(NDS_MMISC_CTL) & (1 << 1)) {
//		/* External PLIC interrupt is vectored */
//		__nds__plic_set_feature(NDS_PLIC_FEATURE_PREEMPT | NDS_PLIC_FEATURE_VECTORED);
//	} else {
//		/* External PLIC interrupt is NOT vectored */
//		__nds__plic_set_feature(NDS_PLIC_FEATURE_PREEMPT);
//	}

	/* Enable Misaligned access */
	set_csr(NDS_MMISC_CTL, (1 << 6));

	/* Initial UART port */
	//uart_init(38400);
}
